<?php
/*
  $Id: view_counter_db_handler.php, v 3.0 by Jack_mcs

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce
  Portions Copyright 2012 oscommerce-solution.com

  Released under the GNU General Public License
  
  **********************************************************************
  Run this script to install, update or delete View Counter in the database.
  Use this url to execute the script. The code will determine what to do
  and provide options.
  
  http://....com/view_counter_db_handler.php
  
  **********************************************************************  
*/

  require('includes/application_top.php');
  
  define('THIS_ADDON', 'View Counter');
  define('THIS_ADDON_DESCRIPTION', 'Server wide settings for ' . THIS_ADDON);
  define('THIS_FILE', 'view_counter_db_handler.php');
  define('THIS_FORM', 'view_counter_db_handler');  
  
  $do_delete = (isset($_GET['delete']) ? true : false);
  $do_reset  = (isset($_GET['reset'])  ? true : false);
 
  if (isset($_POST['action']) && $_POST['action'] == 'process') {
      if (isset($_POST['delete'])) {
          $do_delete = true;
      } else if (isset($_POST['reset'])) {
          $do_reset = true;          
      } else if (isset($_POST['exit'])) {   
          unlink(THIS_FILE);      
          tep_redirect(tep_href_link('index.php'));          
      } else if (isset($_POST['goto'])) {          //end of run - just go to home page
          tep_redirect(tep_href_link('index.php'));          
      } else if (isset($_POST['goto_delete'])) {   //end of run - just go to home page after deleting this file
          unlink(THIS_FILE);      
          tep_redirect(tep_href_link('index.php'));          
      } else if (isset($_POST['goto_install'])) {   //fall through like a new run
      } else {  //catch-all
          unlink(THIS_FILE);      
          tep_redirect(tep_href_link('index.php'));
      }    
  }  
 
  $cfg_group_id = 0;
  $db_query = tep_db_query("select configuration_group_id from configuration_group where configuration_group_title = '" . THIS_ADDON . "'");
  if (tep_db_num_rows($db_query)) {    
      if ($do_delete) {
          $db = tep_db_fetch_array($db_query);
          tep_db_query("delete from configuration_group where configuration_group_id = '" . (int)$db['configuration_group_id'] . "'");   
          tep_db_query("delete from configuration where configuration_group_id = '" . (int)$db['configuration_group_id'] . "'");   
          tep_db_query("DROP TABLE IF EXISTS view_counter");
          tep_db_query("DROP TABLE IF EXISTS view_counter_storage");
          tep_db_query("DROP TABLE IF EXISTS view_counter_banned");
          tep_db_query("DROP TABLE IF EXISTS view_counter_block_list");
          tep_db_query("DROP TABLE IF EXISTS view_counter_blocked");
          tep_db_query("DROP TABLE IF EXISTS view_counter_emails");
          tep_db_query("DROP TABLE IF EXISTS view_counter_flags");
          tep_db_query("DROP TABLE IF EXISTS view_counter_word_tracker");
          tep_db_query("DROP TABLE IF EXISTS view_counter_word_tracker_ips");
          tep_db_query("DROP TABLE IF EXISTS view_counter_session_kill");
          tep_db_query("DROP TABLE IF EXISTS view_counter_settings");
          tep_db_query("DROP TABLE IF EXISTS view_counter_ignore");
      } else if ($do_reset) {
          $db = tep_db_fetch_array($db_query);
          $cfg_group_id = (int)$db['configuration_group_id'];   
          tep_db_query("delete from configuration where configuration_group_id = '" . (int)$db['configuration_group_id'] . "'");   
      } else {
          echo 'Looks like ' . THIS_ADDON . ' is already installed.<br>';
          echo 'Choose one of the following options.<br><br>';
         
          echo tep_draw_form('begin', THIS_FILE, 'post') . tep_hide_session_id() . tep_draw_hidden_field('action', 'process'); ?>
          <div style="padding-bottom:10px"><input type="submit" name="delete" value="Reload This Page and Set Delete Option"></div>
          <div style="padding-bottom:10px"><input type="submit" name="reset" value="Reload This Page and Set Reset Option"></div>
          <div style="padding-bottom:10px"><input type="submit" name="exit" value="Go To Home Page AFTER deleting this file"></div>
        </form> 
        <?php
	         exit;
      }
  } 
  
  $db_sql_array = array(); 
  if ( ! $do_delete ) {  //only new runs and resets
      if ($cfg_group_id == 0) {
          $db_check_query = tep_db_query("select max(configuration_group_id) as id from configuration_group ");
          $max = tep_db_fetch_array($db_check_query);
          $cfg_group_id = $max['id'] + 1;
          tep_db_query("insert into configuration_group (configuration_group_id, configuration_group_title, configuration_group_description, sort_order, visible ) VALUES ('" . $cfg_group_id . "', '" . THIS_ADDON . "', '" . THIS_ADDON_DESCRIPTION . "', '" . (int)$cfg_group_id . "' , '1')");
      } 
    
      // create configuration variables
      $fields = " configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added, use_function ";
      $fields_short = " configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added ";
 
      $sortID = 1;
      $db_sql_array = array( 
                       array("INSERT INTO configuration (" . $fields . ")        VALUES ('ON/OFF', 'VIEW_COUNTER_ENABLED', 'false', '<center><b><h2>View Counter</h2><i>Developed by:</i><br>Jack York @ Oscommerce Solution<br><a href=\"\/\/oscommerce-solution.com\//check_unreleased_updates.php?id=1.9&name=ViewCounter\" target=\"_blank\">Check Updates</a></b></center><br>Site monitoring', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"),
                       array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Active Time','VIEW_COUNTER_ACTIVE_TIME', '10', 'The number of minutes to show active visitors.', '" . $cfg_group_id . "', '" . ($sortID++). "', now())"),
                       array("INSERT INTO configuration (" . $fields . ")        VALUES ('Allow IPv6 IP\'s', 'VIEW_COUNTER_ALLOW_IPV6', 'False', 'Allow the code to handle or ignore IP\'s in the v6 format. Should be False unless the Pro version is being used.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now(), NULL)"),
                       array("INSERT INTO configuration (" . $fields . ")        VALUES ('Autofill Create Account', 'VIEW_COUNTER_AUTOFILL', 'false', 'Autofill some of the fields on the create account and new address pages.<br>(true=on false=off)', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"),
                       array("INSERT INTO configuration (" . $fields . ")        VALUES ('Bad Bot Trap', 'VIEW_COUNTER_BAD_BOT_TRAP', 'Email', 'Choose how to handle the bad bot trap.<br><br><b>Ban:</b> Ban the IP<br><b>Email:</b> Send an Email containing the IP<br><b>Both:</b> Both of the above<br><b>Off:</b> Nothing will be done', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'Ban\', \'Email\', \'Both\', \'Off\'), ', now(), NULL)"),
                       array("INSERT INTO configuration (" . $fields . ")        VALUES ('Block Countries Shop', 'VIEW_COUNTER_BLOCK_COUNTRIES_SHOP', 'Off', '<br><b>Off:</b> Not Enabled.<br><br><b>Internal Only:</b> Only use the internal database.<br><br><b>Internal & External:</b> Use the internal database and external sites. More likely to find the country but may slow the site down.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'Off\', \'Internal\', \'External\'), ', now(), NULL)"),
                       array("INSERT INTO configuration (" . $fields . ")        VALUES ('Block Countries Allow Bots', 'VIEW_COUNTER_BLOCK_COUNTRIES_BOTS', 'Off', '<b>Off</b>: If block countries shop is enabled, block all, even search engines.<br><br><b>On</b>: If block countries shop is enabled, do not block search engines.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'Off\', \'On\'), ', now(), NULL)"), 
                       array("INSERT INTO configuration (" . $fields . ")        VALUES ('Countries Check Admin', 'VIEW_COUNTER_COUNTRIES_CHECK_ADMIN', 'Internal', '<br><b>Internal:</b> Only use the internal database.<br><br><b>External:</b> Use the internal database and external sites. This is more likely to find the country but may slow the site down.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'Internal\', \'External\'), ', now(), NULL)"),

                       array("INSERT INTO configuration (" . $fields . ")        VALUES ('<font color=purple>Create Account Check (Pro Version Only)</font>','VIEW_COUNTER_CREATE_ACCOUNT_CHECK', 'false', 'Check create account for multiple entries in too short of a period.<br>(true=on false=off)', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"),
                       array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('<font color=purple>Create Account Check Period (Pro Version Only)</font>','VIEW_COUNTER_CREATE_ACCOUNT_CHECK_PERIOD', '5', 'The number of minutes a person must wait before creating a second account. The Create Account Check must be enabled.', '" . $cfg_group_id . "', '" . ($sortID++). "', now())"),
                       array("INSERT INTO configuration (" . $fields . ")        VALUES ('<font color=purple>Create Account Notification (Pro Version Only)</font>','VIEW_COUNTER_CREATE_ACCOUNT_NOTIFICATION', 'false', 'Email the address set in the Send Emails setting to show the attempt at creating another account.<br>(true=on false=off)', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"),
        
                       array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('<font color=purple>Data Skimmers Minimum Count (Pro Version Only)</font>','VIEW_COUNTER_DATA_SKIMMER_MIN_COUNT', '100', 'The minimum number of clicks before an IP is considered to be a skimmer.', '" . $cfg_group_id . "', '" . ($sortID++). "', now())"),
                       array("INSERT INTO configuration (" . $fields . ")        VALUES ('<font color=purple>Data Skimmers Show Bots (Pro Version Only)</font>','VIEW_COUNTER_DATA_SKIMMER_SHOW_BOTS', 'false', 'Include search bots when evaluating skimmers. This may be useful to identify bad bots and spoofers. If enabled, be careful when banning any that show since they may be legitimate bots.<br>(true=on false=off)', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"),
                       array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('<font color=purple>Data Skimmers Period of Time (Pro Version Only)</font>','VIEW_COUNTER_DATA_SKIMMER_PERIOD', '24', 'The amount of time, in hours, to check for skimmers. So 24 would mean to check the log for the last 24 hours.', '" . $cfg_group_id . "', '" . ($sortID++). "', now())"),
                       array("INSERT INTO configuration (" . $fields . ")        VALUES ('<font color=purple>Email Tracking (Pro Version Only)</font>','VIEW_COUNTER_EMAIL_TRACK', 'true', 'Records all emails sent from the shop along with the IP used to send the email.<br>(true=on false=off)', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"),
                       array("INSERT INTO configuration (" . $fields . ")        VALUES ('<font color=purple>Email Word Filter (Pro Version Only)</font>','VIEW_COUNTER_EMAIL_WORD_FILTER', 'false', 'Refuse emails that contain any of the words as entered in View Counters Tools.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"),
                       array("INSERT INTO configuration (" . $fields . ")        VALUES ('<font color=purple>Enable Word Tracker (Pro Version Only)</font>','VIEW_COUNTER_ENABLE_WORD_TRACKER', 'False', 'Enable to have View Counter record all word searches. (True=on False=off)', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now(), NULL)"),
                       array("INSERT INTO configuration (" . $fields . ")        VALUES ('<font color=purple>IP Count Show Method (Pro Version Only)</font>','VIEW_COUNTER_IP_COUNT_SHOW_METHOD', 'Click', 'Display the IP count page with a click or mouseover.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'Click\', \'Hover\'), ', now(), NULL)"),
                       array("INSERT INTO configuration (" . $fields . ")        VALUES ('<font color=purple>IP Block by .htaccess (Pro Version Only)</font>','VIEW_COUNTER_IP_BLOCK_HTACCESS', 'True', 'Block IP\'s using the .htaccess file or the database. Using the database can be faster when the number of IP\'s is high.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now(), NULL)"),
                       
                       array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Database','VIEW_COUNTER_DATABASE', 'view_counterDB.BIN', 'The name of the database to be used. The database file must be in the includes/view_counter/ directory.', '" . $cfg_group_id . "', '" . ($sortID++). "', now())"),
                       array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Database DB Code','VIEW_COUNTER_DATABASE_DOWNLOAD_DB_CODE', 'DB9LITEBIN', 'The code used for the database file to be downloaded. Get the code <a href=\"https:\/\/lite.ip2location.com\/file-download\">here<\/a>', '" . $cfg_group_id . "', '" . ($sortID++). "', now())"),
                       array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Database DB Token','VIEW_COUNTER_DATABASE_DOWNLOAD_DB_TOKEN', '', 'The token used for downloading the database. This is found in your account at IP2Location.', '" . $cfg_group_id . "', '" . ($sortID++). "', now())"),
                       
                       array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Date Format','VIEW_COUNTER_DATE_FORMAT', '%a, %D %T', 'The format of the displayed date and time. This requires a valid string so only change it if you are familiar with the format.<br><br><b>12 hr:</b> %a, %D %r => Sun, 14th 01:39:56 PM<br><b>24 hr:</b> %a, %D %T => Sun, 14th 13:39:56<br><br>', '" . $cfg_group_id . "', '" . ($sortID++). "', now())"),
                       array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Force Reset','VIEW_COUNTER_FORCE_RESET', '2', 'The maximum number of days to keep the IP\'s in the database. The View counter table will grow very large if not cleared and data over a few days is probably of no use.', '" . $cfg_group_id . "', '" . ($sortID++). "', now())"),
                       array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Force Reset Storage','VIEW_COUNTER_FORCE_RESET_STORAGE', '14', 'The maximum number of days to keep the IP\'s in the storage table. This table is used for reports. It will grow very large if not cleared on a regular basis.', '" . $cfg_group_id . "', '" . ($sortID++). "', now())"),
                       array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Good IP List','VIEW_COUNTER_GOOD_IP_LIST', '', 'Ignore these IP\'s when banning. Use a comma separated list for multiple IP\'s.', '" . $cfg_group_id . "', '" . ($sortID++). "', now())"),
                       array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Hide Admin Links','VIEW_COUNTER_HIDE_ADMIN_LINKS', '', 'Do not show admin links for these IP\'s. Use a comma separated list for multiple IP\'s.', '" . $cfg_group_id . "', '" . ($sortID++). "', now())"),
                       array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Item Name Length','VIEW_COUNTER_ITEM_NAME_LENGTH', '20', 'The length of the names of the categories, manufacturers and products used in the monitor and report sections.', '" . $cfg_group_id . "', '" . ($sortID++). "', now())"),
                       array("INSERT INTO configuration (" . $fields . ")        VALUES ('Kick Off', 'VIEW_COUNTER_ENABLE_KILL_SESSION', 'false', 'Enable the ability to kick off customers.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"),
                       array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Page Refresh Period','VIEW_COUNTER_PAGE_REFRESH', '120', 'How often, in seconds, to refresh the main page in admin.', '" . $cfg_group_id . "', '" . ($sortID++). "', now())"),
                       
                       array("INSERT INTO configuration (" . $fields . ")        VALUES ('Report Display', 'VIEW_COUNTER_REPORT_DISPLAY', 'Table', 'This is the default setting for reports that can display as a table, a chart or both. The view can be temporairly changed on the report page.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'Chart\', \'Table\', \'Both\'), ', now(), NULL)"),
                       array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Rows Per Page','VIEW_COUNTER_MAX_ROWS', '20', 'The maximum number of rows to display in the list.', '" . $cfg_group_id . "', '" . ($sortID++). "', now())"),
                       array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Send Emails To','VIEW_COUNTER_SEND_EMAILS_TO', '', 'Send any emails created by View Counter to the following address(s). Separate multiple addresses with a comma. If left empty, the shops email address will be used.', '" . $cfg_group_id . "', '" . ($sortID++). "', now())"),
                       array("INSERT INTO configuration (" . $fields . ")        VALUES ('<font color=purple>Show Cart Inline (Pro Version Only)</font>', 'VIEW_COUNTER_SHOW_CART_INLINE', 'false', 'Display the cart contents on the page. If set to false, the contents are shown in a popup. <br>(true=on false=off)', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"),
                       array("INSERT INTO configuration (" . $fields . ")        VALUES ('Show Flags', 'VIEW_COUNTER_SHOW_FLAGS', 'true', 'Display the country flags. Turning this off will speed up the display. <br>(true=on false=off)', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"),
                       array("INSERT INTO configuration (" . $fields . ")        VALUES ('Show Account Details', 'VIEW_COUNTER_SHOW_ACCOUNT_DETAILS', 'true', 'Display the account details of the visitor, if possible. If multiple accounts exist, they will all be shown. Enabling this option may cause a slow-down, depending upon the site. <br>(true=on false=off)', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"),
                       array("INSERT INTO configuration (" . $fields . ")        VALUES ('Version Checker', 'VIEW_COUNTER_ENABLE_VERSION_CHECKER', 'false', 'Enable to automatically check if a new version is available. <br>(true=on false=off)', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)")
      );
      
      $tables = array(
                  array("SET sql_notes = 0"),  //Temporarily disable the "Table already exists" warning
                  array("CREATE TABLE IF NOT EXISTS view_counter (ip_active tinyint (1) DEFAULT 1,isbot tinyint (1) DEFAULT 0,isadmin varchar (64) DEFAULT '',ip_number INT( 64 ) UNSIGNED NOT NULL,session_id varchar (128) DEFAULT '',file_name varchar (64) DEFAULT '',arg varchar (128) DEFAULT '',view_count int (11) DEFAULT 0,last_date datetime NOT NULL,bot_name VARCHAR (64) DEFAULT '', referrer VARCHAR (256) DEFAULT '', referrer_query VARCHAR (256) DEFAULT '', user_agent VARCHAR (256) DEFAULT '', language_id int DEFAULT '1' NOT NULL,index idx_file_name (file_name),index idx_ip_number (ip_number),index idx_language_id (language_id)) ENGINE=InnoDB"),
                  array("CREATE TABLE IF NOT EXISTS view_counter_storage (ip_active tinyint (1) DEFAULT 1,isbot tinyint (1) DEFAULT 0,isadmin varchar (64) DEFAULT '',ip_number INT( 64 ) UNSIGNED NOT NULL,session_id varchar (128) default '',file_name varchar (64) DEFAULT '',arg varchar (128) DEFAULT '',view_count int (11) DEFAULT 0,last_date datetime NOT NULL,bot_name VARCHAR (64) DEFAULT '', referrer VARCHAR (256) DEFAULT '', referrer_query VARCHAR (256) DEFAULT '', user_agent VARCHAR (256) DEFAULT '', language_id int DEFAULT '1' NOT NULL,index idx_file_name (file_name),index idx_ip_number (ip_number),index idx_language_id (language_id)) ENGINE=InnoDB"),
                  array("CREATE TABLE IF NOT EXISTS view_counter_banned (ip_number INT( 64 ) UNSIGNED NOT NULL, ip_string VARCHAR (64) NULL DEFAULT NULL, ignore_status tinyint (1) DEFAULT '0' NOT NULL, index idx_ip_number (ip_number), index idx_ip_string (ip_string)) ENGINE=InnoDB"),
                  array("CREATE TABLE IF NOT EXISTS view_counter_block_list (name_to_block VARCHAR (32) NOT NULL, index idx_name_to_block (name_to_block)) ENGINE=InnoDB"),
                  array("CREATE TABLE IF NOT EXISTS view_counter_blocked (ip_number INT( 64 ) UNSIGNED NOT NULL, country VARCHAR (32) NULL DEFAULT NULL, count int (11) DEFAULT '0' NOT NULL, index idx_ip_number (ip_number)) ENGINE=InnoDB"),
                  array("CREATE TABLE IF NOT EXISTS view_counter_emails (ip_number INT( 64 ) UNSIGNED NOT NULL, sent TINYINT ( 1 ) DEFAULT 0, index idx_ip_number (ip_number)) ENGINE=InnoDB"),
                  array("CREATE TABLE IF NOT EXISTS view_counter_flags (ip_number INT( 64 ) UNSIGNED NOT NULL, data blob NOT NULL, index idx_ip_number (ip_number)) ENGINE=InnoDB"),
                  
                  array("CREATE TABLE IF NOT EXISTS view_counter_word_tracker (
                          id int NOT NULL auto_increment, 
                          word varchar (128) DEFAULT '',
                          count int (11) DEFAULT 1,  
                          found tinyint (1) DEFAULT 0,
                          PRIMARY KEY (id)
                         ) CHARACTER SET utf8 COLLATE utf8_unicode_ci"),  
                  array("CREATE TABLE IF NOT EXISTS view_counter_word_tracker_ips (
                          id int DEFAULT 0,
                          ip INT( 64 ) UNSIGNED NOT NULL, 
                          index idx_ip (ip)
                         ) CHARACTER SET utf8 COLLATE utf8_unicode_ci"),  
                         
                  array("CREATE TABLE IF NOT EXISTS view_counter_session_kill (session_id varchar (128) DEFAULT '', session_msg text NOT NULL) ENGINE=InnoDB"),
                  array("CREATE TABLE IF NOT EXISTS view_counter_settings (page_name varchar (32) DEFAULT '', sort_by varchar (64) DEFAULT '', sort_by_array tinyblob NOT NULL, show_type varchar (64) DEFAULT '', show_type_array tinyblob NOT NULL, sort_direction_array tinyblob NOT NULL, view_active varchar (10) DEFAULT '', view_spoofed varchar (10) DEFAULT '', view_hackers varchar (10) DEFAULT '', display_table varchar (10) DEFAULT '', colors mediumblob NOT NULL, group_data mediumblob NOT NULL) ENGINE=InnoDB"),
                  array("CREATE TABLE IF NOT EXISTS view_counter_ignore (ip_number INT( 64 ) UNSIGNED NOT NULL, UNIQUE KEY idx_ip_number (ip_number)) ENGINE=InnoDB"),
                  array("CREATE TABLE IF NOT EXISTS view_counter_account (count int(11) DEFAULT 0, ip_number INT( 64 ) UNSIGNED NOT NULL, last_date datetime NOT NULL, UNIQUE KEY idx_ip_number (ip_number)) ENGINE=InnoDB"),
                  array("SET sql_notes = 1")      //Re-enable the warning again
                );
                
      $db_sql_array = array_merge($db_sql_array, $tables);
 
      if ( $do_reset ) { 
          $updates = array(
                       array("ALTER TABLE `view_counter` CHANGE `user_agent` `user_agent` VARCHAR( 256 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL;"),
                       array("ALTER TABLE `view_counter` CHANGE `isadmin` `isadmin` VARCHAR(64) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL;"),
                       array("ALTER TABLE `view_counter_storage` CHANGE `user_agent` `user_agent` VARCHAR( 256 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL;"),
                       array("ALTER TABLE `view_counter_storage` CHANGE `isadmin` `isadmin` VARCHAR(64) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL;")
                     );

          $check = tep_db_query("SHOW COLUMNS FROM `view_counter_settings` LIKE 'view_hackers'");
          if (! tep_db_num_rows($check)) {
              $updates[] = array("ALTER TABLE `view_counter_settings` ADD view_hackers varchar (10) DEFAULT '' AFTER view_spoofed");           
          }            
           
          $check = tep_db_query("show tables like 'view_counter_word_tracker'");            
          if (! tep_db_num_rows($check)) {
              $updates[] = array("CREATE TABLE IF NOT EXISTS view_counter_word_tracker (
                                  id int NOT NULL auto_increment, 
                                  word varchar (128) DEFAULT '',
                                  count int (11) DEFAULT 1,  
                                  found tinyint (1) DEFAULT 0,
                                  PRIMARY KEY (id)
                                 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci");
          }                     
          $check = tep_db_query("show tables like 'view_counter_word_tracker_ips'");            
          if (! tep_db_num_rows($check)) {
              $updates[] = array("CREATE TABLE IF NOT EXISTS view_counter_word_tracker_ips (
                                  id int DEFAULT 0,
                                  ip INT( 64 ) UNSIGNED NOT NULL, 
                                  index idx_ip (ip)
                                 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci");            
          }          
          
          $db_sql_array = array_merge($db_sql_array, $updates);
      }
                 
  }
 
  // insert settings
  foreach ($db_sql_array as $sql_array) {
      foreach ($sql_array as $value) {
          if (tep_db_query($value) == false) {
              echo 'An error has occurred while inserting the settings. Aborting!';
              exit;
          }
      }  
  }
 

?>
<div class="pageHeading"><?php echo THIS_ADDON . ' Database Handler'; ?></div>
<div style="padding:10px 0">
<?php
  if ($do_delete) {
      echo 'Database successfully Removed for ' . THIS_ADDON , '!!!';
  } else if ($do_reset) {
      echo 'Database successfully Updated for ' . THIS_ADDON , '!!!';
  } else {
      echo 'Database successfully Installed for ' . THIS_ADDON , '!!!';
  }
?>
</div>

<?php echo tep_draw_form(THIS_FORM, THIS_FILE, 'post') . tep_hide_session_id() . tep_draw_hidden_field('action', 'process'); ?>
  <?php if ($do_delete) { ?>
  <div style="padding-bottom:10px"><input type="submit" name="goto_install" value="Install Again"></div>
  <?php } ?>
  <div style="padding-bottom:10px"><input type="submit" name="goto_delete" value="Go To Home Page AFTER deleting this file (recommended)"></div>
  <div style="padding-bottom:10px"><input type="submit" name="goto" value="Go To Home Page"></div>
</form> 


